;
; Tests
;

.686P
.MMX
.XMM
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED
OPTION LJMP
OPTION CASEMAP:NONE


;
; inc files
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc


;
; lib files
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\masm32.lib


;
; Equ
;
Number_Of_Tests	EQU 2
Number_Of_Loop		EQU 9999
Memory_Block_Size	EQU 1024*1024*6
A_D_P			EQU DWORD*4	;DWORD*2	; automatic data prefetcher value 64 bits for firsts p4... 128 bits for later p4+

;
; protos
;

;Test1 PROTO
;Test2 PROTO
;Test3 PROTO
;Test4 PROTO
;Test5 PROTO
;Test6 PROTO
;Test7 PROTO
;Test8 PROTO
;Main PROTO


.DATA
;
; Structures
;

; structure used to get/free the memory instance
Mem_Info	STRUCT
	Instance			DWORD ?
	Init_Size			DWORD ?
	Maxi_Size			DWORD ?
	Unused_01			DWORD ?
Mem_Info	ENDS

; structure used to alloc/free memory Area
Mem_Area	STRUCT
	Area_Size			DWORD ?
	Pointer_To_Free	DWORD ?
	Pointer			DWORD ?
	Unused_01			DWORD ?
Mem_Area	ENDS

;
Thread_Datas	STRUCT
	Arg_1			DWORD ?	; size
	Arg_2			DWORD ?	; (ADP/Core)*2
	Arg_3			DWORD ?	; filling value
	Arg_4			DWORD ?	; start address
	Arg_5			DWORD ?	; function
	Arg_6			DWORD ?
	Arg_7			DWORD ?
	Arg_8			DWORD ?
Thread_Datas	ENDS


.DATA
ALIGN 16
;
; Variables
;
Tests_Counter	DWORD ?
App_Handle	DWORD ?

ALIGN 16
Thread_1		DWORD ?
Thread_1_Allowed	DWORD ?
Background_Task_1_Done	DWORD ?

ALIGN 16
Thread_2		DWORD ?
Thread_2_Allowed	DWORD ?
Background_Task_2_Done	DWORD ?

ALIGN 16
Thread_3		DWORD ?
Thread_3_Allowed	DWORD ?
Background_Task_3_Done	DWORD ?


szIdTest1		BYTE 13,10," Test 1 (default hardware), done in ",0
szIdTest2		BYTE " Test 2 (attempt core2 ADP usage), done in ",0
szIdTest3		BYTE " Test 3, done in ",0
szIdTest4		BYTE " Test 4, done in ",0
szIdTest5		BYTE " Test 5, done in ",0
szIdTest6		BYTE " Test 6, done in ",0
szIdTest7		BYTE " Test 7, done in ",0
szIdTest8		BYTE " Test 8, done in ",0


ALIGN 16
; Structured variables
Mem_Instance		Mem_Info <?>
Mem_Area_1		Mem_Area <?>
;Mem_Area_2		Mem_Area <?>

Thread_1_Datas		Thread_Datas <?>
Thread_2_Datas		Thread_Datas <?>
Thread_3_Datas		Thread_Datas <?>


.CODE
;
; macros
;
INCLUDE \Masm32\MACROS\macros.asm
INCLUDE timers.asm


.CODE
;
; the procs used
;


ALIGN 16
;
; alloc an align 16 memory area
; note : the Mem_Info structure have to be defined previously, and must be free at the end of the program
;
; Syntax :
; mov eax,size of the memory area to alloc
; mov esi,OFFSET of a Mem_Info structure
; mov edi,OFFSET of a Mem_Area structure
; call AllocMemArea
;
; Return :
; eax = address of the aligned memory area
;
AllocMemArea PROC
		push ecx
		push edx

		mov (Mem_Area PTR [edi]).Area_Size,eax
		add eax,000000010h
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax
		mov (Mem_Area PTR [edi]).Pointer_To_Free,eax
		mov ecx,eax
		and ecx,00000000Fh
		jz AlreadyOk
		and eax,0FFFFFFF0h
		add eax,000000010h
AlreadyOk:
		mov (Mem_Area PTR [edi]).Pointer,eax

		pop edx
		pop ecx
	ret
AllocMemArea ENDP


ALIGN 16
;
; create a memory instance
; note : must be free at the end of the program
;
; Syntax :
; mov esi,OFFSET of a Mem_Info structure
; call CreateMemInstance
;
; Return :
; eax = the instance
;
CreateMemInstance PROC
		push ecx
		push edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(Mem_Info PTR [esi]).Init_Size,(Mem_Info PTR [esi]).Maxi_Size
		mov (Mem_Info PTR [esi]).Instance,eax

		pop edx
		pop ecx
	ret
CreateMemInstance ENDP


ALIGN 16
;
; fill a memory area with a value
;
; Syntax :
; mov eax,size
; mov edx,value
; mov edi,OFFSET memory Area start
; call Fill_Mem
;
; Return :
; nothing
;
Fill_Mem PROC
		push ecx										;; empiler ecx

; ici on traite les owords
		mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label1										;; si ecx est gal  0, aller Label1
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label0:	mov DWORD PTR[edi+ecx],edx						;; placer la valeur en edi+ecx
		mov DWORD PTR[edi+ecx+4],edx						;; placer la valeur en edi+ecx+4
		mov DWORD PTR[edi+ecx+8],edx						;; placer la valeur en edi+ecx+8
		mov DWORD PTR[edi+ecx+12],edx						;; placer la valeur en edi+ecx+12
		add ecx,DWORD*4								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label0									;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les dwords
Label1:	mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label2:	mov DWORD PTR [edi+ecx],edx						;; placer la valeur en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est sign, aller Label2
; ici on traite les octets
Label3:	mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label4:	mov BYTE PTR [edi+ecx],dl						;; placer la valeur en edi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
Label5:	sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop ecx										;; dsempiler ecx
	ret
Fill_Mem ENDP


ALIGN 16
;
; fill a memory area with a value
;
; Syntax :
; mov eax,size
; mov ebx,(ADP value/core)*2
; mov edx,value
; mov edi,OFFSET memory Area start
; call Fill_Mem_2
;
; Return :
; nothing
;
Fill_Mem_2 PROC
		push ecx										;; empiler ecx

; ici on traite les owords
		mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label1										;; si ecx est gal  0, aller Label1
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label0:	mov DWORD PTR[edi+ecx],edx						;; placer la valeur en edi+ecx
		mov DWORD PTR[edi+ecx+4],edx						;; placer la valeur en edi+ecx+4
		mov DWORD PTR[edi+ecx+8],edx						;; placer la valeur en edi+ecx+8
		mov DWORD PTR[edi+ecx+12],edx						;; placer la valeur en edi+ecx+12
		add ecx,ebx									;; on ajoute (ADP value/core)*2  ecx (notre pas de boucle)
		jnz Label0									;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les dwords
Label1:	mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label2:	mov DWORD PTR [edi+ecx],edx						;; placer la valeur en edi+ecx
		add ecx,DWORD*2								;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est sign, aller Label2
; ici on traite les octets
Label3:	mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label4:	mov BYTE PTR [edi+ecx],dl						;; placer la valeur en edi+ecx
		add ecx,BYTE*2									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
Label5:	sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop ecx										;; dsempiler ecx
	ret
Fill_Mem_2 ENDP


ALIGN 16
;
; free a memory area
;
; Syntax :
; mov esi,OFFSET of a Mem_Info structure
; mov edi,OFFSET of a Mem_Area structure
; call FreeMemArea
;
; Return :
; nothing
;
FreeMemArea PROC
		push eax
		push ecx
		push edx

		invoke HeapFree,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE,(Mem_Area PTR [edi]).Pointer_To_Free

		pop edx
		pop ecx
		pop eax
	ret
FreeMemArea ENDP


ALIGN 16
;
; free memory instance (must be done before quit)
;
; Syntax :
; mov esi,OFFSET of a Mem_Info structure
; call FreeMemInstance
;
; Return :
; nothing
;
FreeMemInstance PROC
		push eax
		push ecx
		push edx

		invoke HeapDestroy,(Mem_Info PTR [esi]).Instance

		pop edx
		pop ecx
		pop eax
	ret
FreeMemInstance ENDP




.CODE
;
; Process to test
;


ALIGN 16
;
Fill_Thread_1 PROC WorkToDo:DWORD

NotYet:
	cmp Thread_1_Allowed,TRUE	; needed to wait SuspendThread
	jne NotYet

	mov esi,WorkToDo
	mov eax,(Thread_Datas PTR [esi]).Arg_1
	mov ebx,(Thread_Datas PTR [esi]).Arg_2
	mov edx,(Thread_Datas PTR [esi]).Arg_3
	mov edi,(Thread_Datas PTR [esi]).Arg_4
	mov esi,(Thread_Datas PTR [esi]).Arg_5
	call esi

	mov Thread_1_Allowed,FALSE
	mov Background_Task_1_Done,TRUE	; task done
	jmp NotYet

Fill_Thread_1 ENDP


ALIGN 16
; 
;
; a normal fill
;
; 
Test1 PROC
		pushad

; normal task
	mov eax,Thread_1_Datas.Arg_1
	mov edx,0FFFFFFFFh
	mov edi,Thread_1_Datas.Arg_4
	call Fill_Mem

		popad
	ret
Test1 ENDP


ALIGN 16
; 
;
; x2 parallelism (attempt with benefit of the automatic data prefetcher)
;
; 
Test2 PROC
		pushad

; allow thread
	mov Thread_1_Allowed,TRUE
	mov Background_Task_1_Done,FALSE
	invoke ResumeThread,Thread_1	; launch (Fill_Mem_2)

; normal task 1 (Fill_Mem_2)
	mov eax,Thread_1_Datas.Arg_1
	mov ebx,DWORD*8	; adp*2
	mov edx,0FFFFFFFFh
	mov edi,Thread_1_Datas.Arg_4
	add edi,A_D_P*1
	call Fill_Mem_2

NotYet:
	cmp Background_Task_1_Done,TRUE	; second part done ?
	jne NotYet
	invoke SuspendThread,Thread_1

		popad
	ret
Test2 ENDP


ALIGN 16
; 
;
;
;
; 
Test3 PROC
		pushad



		popad
	ret
Test3 ENDP


ALIGN 16
; 
;
;
;
; 
Test4 PROC
		pushad



		popad
	ret
Test4 ENDP


ALIGN 16
; 
;
;
;
; 
Test5 PROC
		pushad



		popad
	ret
Test5 ENDP


ALIGN 16
; 
;
;
;
; 
Test6 PROC
		pushad



		popad
	ret
Test6 ENDP


ALIGN 16
; 
;
;
;
; 
Test7 PROC
		pushad



		popad
	ret
Test7 ENDP


ALIGN 16
; 
;
;
;
; 
Test8 PROC
		pushad



		popad
	ret
Test8 ENDP




ALIGN 16
; 
;
; main process, where the tests are launched
;
; 
Main PROC

		print chr$(13,10," Results of the tests :",13,10)
		invoke Sleep,1000


	mov Tests_Counter,Number_Of_Tests
TestsLoop:
	add Thread_1_Datas.Arg_1,Memory_Block_Size/2


; test 1
		invoke Sleep,500
		print OFFSET szIdTest1

		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
		call Test1
		counter_end

		print ustr$(eax)," cycles",13,10


; test 2
		invoke Sleep,500
		print OFFSET szIdTest2

	mov eax,OFFSET Fill_Mem_2
	mov Thread_1_Datas.Arg_5,eax
	mov Thread_1_Datas.Arg_2,DWORD*8	; adp*2

		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
		call Test2
		counter_end

		print ustr$(eax)," cycles",13,10


; test 3
		invoke Sleep,500
		print OFFSET szIdTest3

	mov eax,OFFSET Fill_Mem_2
	mov Thread_1_Datas.Arg_5,eax
	mov Thread_1_Datas.Arg_2,DWORD*8	; adp*2

		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
		call Test3
		counter_end

		print ustr$(eax)," cycles",13,10


; test 4
		invoke Sleep,500
		print OFFSET szIdTest4

		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
		call Test4
		counter_end

		print ustr$(eax)," cycles",13,10


;; test 5
;		invoke Sleep,500
;		print OFFSET szIdTest5
;
;		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
;		call Test5
;		counter_end
;
;		print ustr$(eax)," cycles",13,10


;; test 6
;		invoke Sleep,500
;		print OFFSET szIdTest6
;
;		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
;		call Test6
;		counter_end
;
;		print ustr$(eax)," cycles",13,10


;; test 7
;		invoke Sleep,500
;		print OFFSET szIdTest7
;
;		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
;		call Test7
;		counter_end
;
;		print ustr$(eax)," cycles",13,10


;; test 8
;		invoke Sleep,500
;		print OFFSET szIdTest8
;
;		counter_begin Number_Of_Loop,HIGH_PRIORITY_CLASS
;		call Test8
;		counter_end
;
;		print ustr$(eax)," cycles",13,10


	dec Tests_Counter
	jnz TestsLoop

; end tests
		invoke Sleep,1000
		mov eax,input(13,10,13,10," Press ENTER to quit...")
	ret
Main ENDP


.CODE
ALIGN 16
; 
;
; entry point of the program
;
; 

Start:
; alloc mem areas
		mov esi,OFFSET Mem_Instance
		call CreateMemInstance

		mov eax,Memory_Block_Size
;		mov esi,OFFSET Mem_Instance
		mov edi,OFFSET Mem_Area_1
		call AllocMemArea

;		mov eax,Memory_Block_Size
;;		mov esi,OFFSET Mem_Instance
;		mov edi,OFFSET Mem_Area_2
;		call AllocMemArea


; thread 1 (an extra thread for core 2)
	mov Thread_1_Allowed,FALSE
	invoke CreateThread,NULL,1024,ADDR Fill_Thread_1,ADDR Thread_1_Datas,NULL,ADDR Thread_1
	invoke SetThreadPriority,Thread_1,THREAD_PRIORITY_HIGHEST
	invoke SuspendThread,Thread_1
; start to fill the Thread_Datas structure
	mov Thread_1_Datas.Arg_1,0
	mov eax,0FFFFFFFFh
	mov Thread_1_Datas.Arg_3,eax
	mov eax,Mem_Area_1.Pointer
	mov Thread_1_Datas.Arg_4,eax


; launch the tests
		call Main


	invoke SetThreadPriority,Thread_1,THREAD_PRIORITY_NORMAL
	invoke TerminateThread,Thread_1,0

; free mem areas
;		mov esi,OFFSET Mem_Instance
;		mov edi,OFFSET Mem_Area_2
;		call FreeMemArea

		mov esi,OFFSET Mem_Instance
		mov edi,OFFSET Mem_Area_1
		call FreeMemArea

;		mov esi,OFFSET Mem_Instance
		call FreeMemInstance

		Invoke ExitProcess,0
;
END Start


